diff -urN ../VisualBoyAdvance-1.7.2/src/Globals.h ./src/Globals.h
--- ../VisualBoyAdvance-1.7.2/src/Globals.h	2004-05-13 23:04:03 +0900
+++ ./src/Globals.h	2006-08-01 00:51:01 +0900
@@ -1,7 +1,7 @@
 // -*- C++ -*-
 // VisualBoyAdvance - Nintendo Gameboy/GameboyAdvance (TM) emulator.
 // Copyright (C) 1999-2003 Forgotten
-// Copyright (C) 2004 Forgotten and the VBA development team
+// Copyright (C) 2005 Forgotten and the VBA development team
 
 // This program is free software; you can redistribute it and/or modify
 // it under the terms of the GNU General Public License as published by
@@ -20,6 +20,8 @@
 #ifndef VBA_GLOBALS_H
 #define VBA_GLOBALS_H
 
+#include "GBA.h"
+
 #define VERBOSE_SWI                  1
 #define VERBOSE_UNALIGNED_MEMORY     2
 #define VERBOSE_ILLEGAL_WRITE        4
@@ -55,8 +57,8 @@
 extern int layerEnable;
 extern bool speedHack;
 extern int cpuSaveType;
-extern bool cpuEnhancedDetection;
 extern bool cheatsEnabled;
+extern bool mirroringEnable;
 
 extern u8 *bios;
 extern u8 *rom;
diff -urN ../VisualBoyAdvance-1.7.2/src/NLS.h ./src/NLS.h
--- ../VisualBoyAdvance-1.7.2/src/NLS.h	2004-05-13 23:03:44 +0900
+++ ./src/NLS.h	2006-06-07 00:19:25 +0900
@@ -60,3 +60,5 @@
 #define MSG_INVALID_CBA_CODE               39
 #define MSG_CBA_CODE_WARNING               40
 #define MSG_OUT_OF_MEMORY                  41
+#define MSG_WRONG_GAMESHARK_CODE           42
+#define MSG_UNSUPPORTED_GAMESHARK_CODE     43
diff -urN ../VisualBoyAdvance-1.7.2/src/RTC.cpp ./src/RTC.cpp
--- ../VisualBoyAdvance-1.7.2/src/RTC.cpp	2004-05-13 23:36:17 +0900
+++ ./src/RTC.cpp	2006-01-04 22:42:59 +0900
@@ -1,6 +1,6 @@
 // VisualBoyAdvance - Nintendo Gameboy/GameboyAdvance (TM) emulator.
 // Copyright (C) 1999-2003 Forgotten
-// Copyright (C) 2004 Forgotten and the VBA development team
+// Copyright (C) 2005 Forgotten and the VBA development team
 
 // This program is free software; you can redistribute it and/or modify
 // it under the terms of the GNU General Public License as published by
@@ -119,6 +119,8 @@
               rtcClockData.data[0] = 0x40;
               rtcClockData.state = DATA;
               break;
+            case 0x64:
+              break;
             case 0x65:
               {
                 struct tm *newtime;
@@ -131,7 +133,7 @@
                 rtcClockData.data[0] = toBCD(newtime->tm_year);
                 rtcClockData.data[1] = toBCD(newtime->tm_mon+1);
                 rtcClockData.data[2] = toBCD(newtime->tm_mday);
-                rtcClockData.data[3] = 0;
+                rtcClockData.data[3] = toBCD(newtime->tm_wday);
                 rtcClockData.data[4] = toBCD(newtime->tm_hour);
                 rtcClockData.data[5] = toBCD(newtime->tm_min);
                 rtcClockData.data[6] = toBCD(newtime->tm_sec);
diff -urN ../VisualBoyAdvance-1.7.2/src/Sound.cpp ./src/Sound.cpp
--- ../VisualBoyAdvance-1.7.2/src/Sound.cpp	2004-05-13 23:36:07 +0900
+++ ./src/Sound.cpp	2006-08-25 22:30:08 +0900
@@ -1,6 +1,7 @@
 // VisualBoyAdvance - Nintendo Gameboy/GameboyAdvance (TM) emulator.
 // Copyright (C) 1999-2003 Forgotten
 // Copyright (C) 2004 Forgotten and the VBA development team
+// Copyright (C) 2004-2006 VBA development team
 
 // This program is free software; you can redistribute it and/or modify
 // it under the terms of the GNU General Public License as published by
@@ -18,15 +19,16 @@
 
 #include <memory.h>
 
+#include "Sound.h"
+
 #include "GBA.h"
 #include "Globals.h"
-#include "Sound.h"
 #include "Util.h"
 
 #define USE_TICKS_AS  380
 #define SOUND_MAGIC   0x60000000
 #define SOUND_MAGIC_2 0x30000000
-#define NOISE_MAGIC 5
+#define NOISE_MAGIC   5
 
 extern bool stopState;
 
@@ -387,8 +389,8 @@
       sound2Index = 0;
       sound2On = 1;
     }
-    break;
-    ioMem[address] = data;    
+    ioMem[address] = data;  
+    break;  
   case NR30:
     data &= 0xe0;
     if(!(data & 0x80)) {
@@ -541,7 +543,7 @@
   switch(address) {
   case SGCNT0_H:
     data &= 0xFF0F;
-    soundControl = data & 0x770F;;
+    soundControl = data & 0x770F;
     if(data & 0x0800) {
       soundDSFifoAWriteIndex = 0;
       soundDSFifoAIndex = 0;
@@ -560,7 +562,7 @@
     }
     soundDSBEnabled = (data & 0x3000) ? true : false;
     soundDSBTimer = (data & 0x4000) ? 1 : 0;
-    *((u16 *)&ioMem[address]) = data;    
+    *((u16 *)&ioMem[address]) = soundControl;    
     break;
   case FIFOA_L:
   case FIFOA_H:
@@ -865,7 +867,7 @@
     }
     
     soundDSAValue = (soundDSFifoA[soundDSFifoAIndex]);
-    soundDSFifoAIndex = (++soundDSFifoAIndex) & 31;
+    soundDSFifoAIndex = (soundDSFifoAIndex + 1) & 31;
     soundDSFifoACount--;
   } else
     soundDSAValue = 0;
@@ -894,7 +896,7 @@
     }
     
     soundDSBValue = (soundDSFifoB[soundDSFifoBIndex]);
-    soundDSFifoBIndex = (++soundDSFifoBIndex) & 31;
+    soundDSFifoBIndex = (soundDSFifoBIndex + 1) & 31;
     soundDSFifoBCount--;
   } else {
     soundDSBValue = 0;
diff -urN ../VisualBoyAdvance-1.7.2/src/Sound.h ./src/Sound.h
--- ../VisualBoyAdvance-1.7.2/src/Sound.h	2004-05-13 23:03:07 +0900
+++ ./src/Sound.h	2006-06-07 06:04:20 +0900
@@ -2,6 +2,7 @@
 // VisualBoyAdvance - Nintendo Gameboy/GameboyAdvance (TM) emulator.
 // Copyright (C) 1999-2003 Forgotten
 // Copyright (C) 2004 Forgotten and the VBA development team
+// Copyright (C) 2004-2006 VBA development team
 
 // This program is free software; you can redistribute it and/or modify
 // it under the terms of the GNU General Public License as published by
@@ -20,6 +21,8 @@
 #ifndef VBA_SOUND_H
 #define VBA_SOUND_H
 
+#include "System.h"
+
 #define NR10 0x60
 #define NR11 0x62
 #define NR12 0x63
@@ -47,23 +50,22 @@
 #define FIFOB_L 0xa4
 #define FIFOB_H 0xa6
 
-extern void soundTick();
-extern void soundShutdown();
-extern bool soundInit();
-extern void soundPause();
-extern void soundResume();
-extern void soundEnable(int);
-extern void soundDisable(int);
-extern int  soundGetEnable();
-extern void soundReset();
-extern void soundSaveGame(gzFile);
-extern void soundReadGame(gzFile, int);
-extern void soundEvent(u32, u8);
-extern void soundEvent(u32, u16);
-extern void soundTimerOverflow(int);
-extern void soundSetQuality(int);
+void soundTick();
+void soundShutdown();
+bool soundInit();
+void soundPause();
+void soundResume();
+void soundEnable(int);
+void soundDisable(int);
+int  soundGetEnable();
+void soundReset();
+void soundSaveGame(gzFile);
+void soundReadGame(gzFile, int);
+void soundEvent(u32, u8);
+void soundEvent(u32, u16);
+void soundTimerOverflow(int);
+void soundSetQuality(int);
 
-//extern int SOUND_TICKS;
 extern int SOUND_CLOCK_TICKS;
 extern int soundTicks;
 extern int soundPaused;
diff -urN ../VisualBoyAdvance-1.7.2/src/Sram.cpp ./src/Sram.cpp
--- ../VisualBoyAdvance-1.7.2/src/Sram.cpp	2004-05-13 23:35:57 +0900
+++ ./src/Sram.cpp	2004-11-15 03:54:14 +0900
@@ -17,6 +17,7 @@
 // Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 
 #include "GBA.h"
+#include "Globals.h"
 #include "Flash.h"
 #include "Sram.h"
 
@@ -24,6 +25,12 @@
 {
   return flashSaveMemory[address & 0xFFFF];
 }
+void sramDelayedWrite(u32 address, u8 byte)
+{
+  saveType = 1;
+  cpuSaveGameFunc = sramWrite;
+  sramWrite(address, byte);
+}
 
 void sramWrite(u32 address, u8 byte)
 {
diff -urN ../VisualBoyAdvance-1.7.2/src/Sram.h ./src/Sram.h
--- ../VisualBoyAdvance-1.7.2/src/Sram.h	2004-05-13 23:02:56 +0900
+++ ./src/Sram.h	2004-11-15 03:54:14 +0900
@@ -22,5 +22,6 @@
 
 extern u8 sramRead(u32 address);
 extern void sramWrite(u32 address, u8 byte);
+extern void sramDelayedWrite(u32 address, u8 byte);
 
 #endif // VBA_SRAM_H
diff -urN ../VisualBoyAdvance-1.7.2/src/System.h ./src/System.h
--- ../VisualBoyAdvance-1.7.2/src/System.h	2004-05-13 23:02:43 +0900
+++ ./src/System.h	2006-06-22 01:58:15 +0900
@@ -106,6 +106,12 @@
 extern void systemFrame();
 extern void systemGbBorderOn();
 
+extern void Sm60FPS_Init();
+extern bool Sm60FPS_CanSkipFrame();
+extern void Sm60FPS_Sleep();
+extern void DbgMsg(const char *msg, ...);
+extern void winlog(const char *,...);
+
 extern bool systemSoundOn;
 extern u16 systemColorMap16[0x10000];
 extern u32 systemColorMap32[0x10000];
@@ -118,6 +124,7 @@
 extern int systemVerbose;
 extern int systemFrameSkip;
 extern int systemSaveUpdateCounter;
+extern int systemSpeed;
 
 #define SYSTEM_SAVE_UPDATED 30
 #define SYSTEM_SAVE_NOT_UPDATED 0
diff -urN ../VisualBoyAdvance-1.7.2/src/Util.cpp ./src/Util.cpp
--- ../VisualBoyAdvance-1.7.2/src/Util.cpp	2004-05-21 02:42:37 +0900
+++ ./src/Util.cpp	2006-05-27 23:47:32 +0900
@@ -1,6 +1,6 @@
 // VisualBoyAdvance - Nintendo Gameboy/GameboyAdvance (TM) emulator.
 // Copyright (C) 1999-2003 Forgotten
-// Copyright (C) 2004 Forgotten and the VBA development team
+// Copyright (C) 2004-2006 Forgotten and the VBA development team
 
 // This program is free software; you can redistribute it and/or modify
 // it under the terms of the GNU General Public License as published by
@@ -47,9 +47,17 @@
 #define _stricmp strcasecmp
 #endif // ! _MSC_VER
 
-static int (*utilGzWriteFunc)(gzFile, const voidp, unsigned int) = NULL;
-static int (*utilGzReadFunc)(gzFile, voidp, unsigned int) = NULL;
-static int (*utilGzCloseFunc)(gzFile) = NULL;
+extern int systemColorDepth;
+extern int systemRedShift;
+extern int systemGreenShift;
+extern int systemBlueShift;
+
+extern u16 systemColorMap16[0x10000];
+extern u32 systemColorMap32[0x10000];
+
+static int (ZEXPORT *utilGzWriteFunc)(gzFile, const voidp, unsigned int) = NULL;
+static int (ZEXPORT *utilGzReadFunc)(gzFile, voidp, unsigned int) = NULL;
+static int (ZEXPORT *utilGzCloseFunc)(gzFile) = NULL;
 
 bool utilWritePNGFile(const char *fileName, int w, int h, u8 *pix)
 {
@@ -478,7 +486,7 @@
 {
   cpuIsMultiBoot = false;
   if(strlen(file) > 4) {
-    char * p = strrchr(file,'.');
+    const char * p = strrchr(file,'.');
 
     if(p != NULL) {
       if(_stricmp(p, ".gba") == 0)
@@ -502,7 +510,7 @@
 bool utilIsGBImage(const char * file)
 {
   if(strlen(file) > 4) {
-    char * p = strrchr(file,'.');
+    const char * p = strrchr(file,'.');
 
     if(p != NULL) {
       if(_stricmp(p, ".gb") == 0)
@@ -522,7 +530,7 @@
 bool utilIsZipFile(const char *file)
 {
   if(strlen(file) > 4) {
-    char * p = strrchr(file,'.');
+    const char * p = strrchr(file,'.');
 
     if(p != NULL) {
       if(_stricmp(p, ".zip") == 0)
@@ -552,7 +560,7 @@
 bool utilIsGzipFile(const char *file)
 {
   if(strlen(file) > 3) {
-    char * p = strrchr(file,'.');
+    const char * p = strrchr(file,'.');
 
     if(p != NULL) {
       if(_stricmp(p, ".gz") == 0)
@@ -937,11 +945,11 @@
     }
     size = fileSize;
   }
-  int read = fileSize <= size ? fileSize : size;
-  int r = fread(image, 1, read, f);
+  size_t read = fileSize <= size ? fileSize : size;
+  size_t r = fread(image, 1, read, f);
   fclose(f);
 
-  if(r != (int)read) {
+  if(r != read) {
     systemMessage(MSG_ERROR_READING_IMAGE,
                   N_("Error reading image %s"), file);
     if(data == NULL)
@@ -984,7 +992,7 @@
 
 gzFile utilGzOpen(const char *file, const char *mode)
 {
-  utilGzWriteFunc = (int (*)(void *,void * const, unsigned int))gzwrite;
+  utilGzWriteFunc = (int (ZEXPORT *)(void *,void * const, unsigned int))gzwrite;
   utilGzReadFunc = gzread;
   utilGzCloseFunc = gzclose;
 
@@ -1034,22 +1042,22 @@
     if(d == 0x52504545) {
       if(memcmp(p, "EEPROM_", 7) == 0) {
         if(saveType == 0)
-          saveType = 1;
+          saveType = 3;
       }
     } else if (d == 0x4D415253) {
       if(memcmp(p, "SRAM_", 5) == 0) {
         if(saveType == 0)
-          saveType = 2;
+          saveType = 1;
       }
     } else if (d == 0x53414C46) {
       if(memcmp(p, "FLASH1M_", 8) == 0) {
         if(saveType == 0) {
-          saveType = 3;
+          saveType = 2;
           flashSize = 0x20000;
         }
       } else if(memcmp(p, "FLASH", 5) == 0) {
         if(saveType == 0) {
-          saveType = 3;
+          saveType = 2;
           flashSize = 0x10000;
         }
       }
@@ -1067,3 +1075,28 @@
   cpuSaveType = saveType;
   flashSetSize(flashSize);
 }
+
+void utilUpdateSystemColorMaps()
+{
+  switch(systemColorDepth) {
+  case 16: 
+    {
+      for(int i = 0; i < 0x10000; i++) {
+        systemColorMap16[i] = ((i & 0x1f) << systemRedShift) |
+          (((i & 0x3e0) >> 5) << systemGreenShift) |
+          (((i & 0x7c00) >> 10) << systemBlueShift);
+      }
+    }
+    break;
+  case 24:
+  case 32:
+    {
+      for(int i = 0; i < 0x10000; i++) {
+        systemColorMap32[i] = ((i & 0x1f) << systemRedShift) |
+          (((i & 0x3e0) >> 5) << systemGreenShift) |
+          (((i & 0x7c00) >> 10) << systemBlueShift);
+      }
+    }
+    break;
+  }
+}
diff -urN ../VisualBoyAdvance-1.7.2/src/Util.h ./src/Util.h
--- ../VisualBoyAdvance-1.7.2/src/Util.h	2004-05-13 23:02:08 +0900
+++ ./src/Util.h	2004-09-16 07:12:52 +0900
@@ -61,4 +61,5 @@
 extern int utilGzClose(gzFile file);
 extern long utilGzMemTell(gzFile file);
 extern void utilGBAFindSave(const u8 *, const int);
+extern void utilUpdateSystemColorMaps();
 #endif
